import javax.microedition.midlet.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.*;
import javax.wireless.messaging.*;
import java.io.IOException;

/***************************************************
Esempio di MIDlet che mostra il contenuto 
letto da un SMS di tipo wap push

Dev By Daniele De Santis

****************************************************/
public class SMS_PUSH_TEST extends MIDlet implements CommandListener, Runnable, MessageListener {
  private Display display;
  private Form form_inizio;
  private Command cmExit;
  private Command cmAbout;
  
  String smsPort = "50000";
  String smsConnectionStr = "sms://:" + smsPort;
  MessageConnection smsConn;
  Thread threadID;
  
  //COSTRUTTORE
  public SMS_PUSH_TEST() {
    display = Display.getDisplay(this);
    cmExit = new Command("Exit", Command.EXIT, 1); //CREA I COMANDI
    cmAbout = new Command("About", Command.SCREEN, 1);
    form_inizio = new Form("SMS PUSH TEST"); //Crea un nuovo form e imposta il titolo
    form_inizio.addCommand(cmExit); //Inserisce i comandi
    form_inizio.addCommand(cmAbout);
    form_inizio.setCommandListener(this);
    display.setCurrent(form_inizio); //Setta il Form di partenza
  }
  
  //Eseguita all'avvio dell'aplicazione
  public void startApp (){
    String midletClassName  = this.getClass().getName();
    String filter = "*";
    
    if (smsConn == null) {
      try {
        smsConn = (MessageConnection) Connector.open(smsConnectionStr);
        smsConn.setMessageListener(this);
      } catch (IOException ioe) {
        show_alert ("Errore", 1, 3000,  form_inizio);
      }
    }
    //Vrifica se l'applicazione  correttamente registrata 
    if (!checkRegistered()){ 
      try {
        PushRegistry.registerConnection (smsConnectionStr, midletClassName, filter);
      } catch ( ClassNotFoundException cnf ) {
        show_alert ("Classe Pushregistry non disponibile su questo cellulare", 1, 3000,  form_inizio);
      } catch (IOException ioe) {
        show_alert ("Applicazione gi registrata", 1, 3000,  form_inizio);
      }
      String[] connections = PushRegistry.listConnections(true);
    }
    
    //done = false;
    threadID = new Thread(this);
    threadID.start();
    
    
    form_inizio.append("In ascolto sulla porta " + smsPort + "\n\n");
  } 
  //Eseguita alla chiusura dell'aplicazione
  public void destroyApp(boolean unconditional) {
    //done = true;
    threadID = null;
    if (smsConn != null) {
      try {
        smsConn.close();
      } catch (IOException e) { }
    }
  } 
  
  public void pauseApp() {} //Eseguita alla messa in pausa dell'aplicazione
  
  //Notifica quando viene ricevuto un messaggio
  //@param conn the connection with messages available
  public void notifyIncomingMessage(MessageConnection conn) {
    if (threadID == null) {
      //done = false;
      threadID = new Thread(this);
      threadID.start();
    }
  }
  //Gestisce i comandi
  public void commandAction(Command command, Displayable displayable){
    if (command == cmExit){  //PRESSIONE TASTO EXIT
      destroyApp(false);
      notifyDestroyed();
    } else if (command == cmAbout){
      //Mostra l'Alert About per 3 Sec
      show_alert ("By DeSantiX.iT\nhttp://www.desantix.it/", 2, 3000,  form_inizio);
    }
  }
  
  //Verifica se l'applicazione  gi registrata
  private boolean checkRegistered() {
    String[] connections = PushRegistry.listConnections(false);
    for (int i = 0; i < connections.length; i++) {
      if (connections[i].equals(smsConnectionStr)) 
        return true; //Applicazione registra correttamente
    } 
    return false; //Registrazione fallita
  } 
  
  //Visualizza i messaggi d'errore 
  public void show_alert (String Message, int Type, int TimeOut, Form Form){
    String title;
    AlertType alertType;
    switch (Type)  {
      default:
      case 0:	//CONFERMA
        title = "Conferma";
        alertType = AlertType.CONFIRMATION;
      break;
      case 1: //ERRORE
        title = "Attenzione";
        alertType = AlertType.ERROR;
      break; 
      case 2:	//INFO
        title = "Info";
        alertType = AlertType.INFO;
      break;		
    }
    Alert alert = new Alert(title, Message, null, alertType);
    alert.setTimeout(TimeOut);
    display.setCurrent(alert, Form);
  }
  
  //Thread per la lettura del SMS
  public void run() {
    String senderNumber;
    String smsTextMesg;
    Message msg;
    try {
      msg = smsConn.receive();
      if (msg != null) {
        senderNumber = msg.getAddress();
        form_inizio.append("SMS da: " + senderNumber + "\n");
        //Estrae il testo del SMS
        if (msg instanceof TextMessage) {
          smsTextMesg = ((TextMessage)msg).getPayloadText();
          //content.setString(sms_text);
        } else {
          StringBuffer buf = new StringBuffer();
          byte[] data = ((BinaryMessage)msg).getPayloadData();
          for (int i = 0; i < data.length; i++) {
            int intData = (int)data[i] & 0xFF;
            if (intData < 0x10) { //Se trova uno \n
              buf.append("0"); //Appende una terminazione di stringa
            }
            buf.append(Integer.toHexString(intData));
            buf.append(' ');
          }
          smsTextMesg = buf.toString(); //body dell'sms!
        }
        //Visualizza un Alert con il testo del SMS!
        form_inizio.append("Messaggio:\n" + smsTextMesg + "\n");
        
      }
    } catch (IOException e) {}
  }
}
